/*
 * Copyright (c) 2021-2022, Linus Groh <linusg@serenityos.org>
 *
 * SPDX-License-Identifier: BSD-2-Clause
 */

#pragma once

#include <LibJS/Runtime/NativeFunction.h>

namespace JS::Temporal {

class PlainYearMonthConstructor final : public NativeFunction {
    JS_OBJECT(PlainYearMonthConstructor, NativeFunction);
    JS_DECLARE_ALLOCATOR(PlainYearMonthConstructor);

public:
    virtual void initialize(Realm&) override;
    virtual ~PlainYearMonthConstructor() override = default;

    virtual ThrowCompletionOr<Value> call() override;
    virtual ThrowCompletionOr<NonnullGCPtr<Object>> construct(FunctionObject& new_target) override;

private:
    explicit PlainYearMonthConstructor(Realm&);

    virtual bool has_constructor() const override { return true; }

    JS_DECLARE_NATIVE_FUNCTION(from);
    JS_DECLARE_NATIVE_FUNCTION(compare);
};

}
